<?php
//require_once('vendor/autoload.php');
use \Firebase\JWT\JWT;

/**         
 *
 * @wordpress-plugin
 * Plugin Name:       Mobile App Newsgain
 * Description:       functions which is used core wp rest API engine for REQUEST and RESPONSE .
 * Version:           1.0
 * Author:            Newsgain ApS
 */

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

add_action('rest_api_init', function()
{
    
    register_rest_route(' ', '/register', array(
        'methods' => 'POST',
        'callback' => 'register'
    ));

    register_rest_route('mobileapi', '/activation', array(
        'methods' => 'GET',
        'callback' => 'activation'
    ));

    register_rest_route('mobileapi', '/forget_password', array(
        'methods' => 'POST',
        'callback' => 'forget_password'
    ));

    register_rest_route('mobileapi', '/update_profile', array(
        'methods' => 'POST',
        'callback' => 'updateProfile'
    ));
  
    
    register_rest_route('mobileapi', '/get_related_post', array(
        'methods' => 'POST',
        'callback' => 'get_related_post'
    ));

    register_rest_route('mobileapi', '/get_comment', array(
        'methods' => 'POST',
        'callback' => 'getComment'
    ));

    register_rest_route('mobileapi', '/submit_comment', array(
        'methods' => 'POST',
        'callback' => 'submitComment'
    ));

    register_rest_route('mobileapi', '/reply_comment', array(
        'methods' => 'POST',
        'callback' => 'replyComment'
    ));
    
    
});

//================= wp backend ==================================

function add_custom_meta_box_noti(){
    add_meta_box("demo-meta-box", "Push Notification", "custom_meta_box_markup", "post", "side", "high", null);
}
add_action("add_meta_boxes", "add_custom_meta_box_noti");

function custom_meta_box_markup($post){
   ?>
   <input type="checkbox" name="send_notification" value="1" <?php echo (get_post_meta($post->ID, "send_notification", true)) ? 'checked' :''; ?>>
   <label>Send Notification To User</label>
  <?php
}
//===============================================================

add_filter('rest_prepare_post', 'func_rest_prepare_post', 10, 3 );
    function func_rest_prepare_post( $data, $post, $request ) {
        $category_detail=get_the_category($data->data['id']);//$post->ID
        $cat_str='';
        foreach($category_detail as $cd){
            $cat_str.=$cd->cat_name."|";
        }
        
        $cats =rtrim($cat_str,"|");
        
        $data->data['category_name']= $cats;
        
        return $data;
}


// send notification to mobile device
add_action( 'draft_to_publish', 'wp_post_published_notification' );
function wp_post_published_notification($post){
    
    if($post->post_type=='post'){
        if($_POST['send_notification']==1){
           update_post_meta($post->ID, "send_notification", $_POST['send_notification']);	
           sendNotification($post);
        }
        
    }
}


/*
add_action( 'publish_post', 'post_published_notification', 10, 2 );
*/
    
function sendNotification($post){
    define( 'API_ACCESS_KEY', 'AAAADKtsouE:APA91bFx92beqBjYcE1Jh91IM8GfK2aXRopFnSIv5RCeeWdOo1Ztm6AauW-xeASYiKAMXL95LpAIWjQzP0k3RQOrPRF43xR_9cZ8Cf6pgoU0I6KnwCkfcMCvRnUXYJJAZXHNdjUYSslT');
    $server_key = API_ACCESS_KEY;
    
    // prep the bundle
    $msg= $post->post_title;
    $data = array(
                  'title'=>'Breaking News',
                  'body'=>$msg,
                  'icon'=>'https://www.zambiawatchdog.com/wp-content/uploads/2017/05/logo-1.png',
                  'sound'=>'default'
                  );
    
    $target = '/topics/all';
    
    $url = 'https://fcm.googleapis.com/fcm/send';
    
    
    $fields = array();
    $fields['notification'] = $data;
    //$fields['data'] = $data;
    if(is_array($target)){
        $fields['registration_ids'] = $target;
    }else{
        $fields['to'] = $target;
    }
    
    $fields['priority'] = "high";
    
    $headers = array(
                     'Content-Type:application/json',
                     'Authorization:key='.$server_key
                     );
    //CURL request to route notification to FCM connection server (provided by Google)
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
    $result = curl_exec($ch);
    if ($result === FALSE) {
        die('Oops! FCM Send Error: ' . curl_error($ch));
    }
    curl_close($ch);
    echo $result;
    
}


//================================================

function register($request){
   global $wpdb;
    $data  = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    );

   
    $param = $request->get_params(); 
   // print_r($param);exit;
    $username= $param['username'];
    $email= $param['email'];
    $password = $param['password'];

    if(!filter_var($email, FILTER_VALIDATE_EMAIL)){
       $data['status']     = "error";
       $data['errormsg']   = __('This is not a Valid Email.');
       $data['error_code'] = "invalid_email";
       return new WP_REST_Response($data, 403);
    }

    // if email already exist
    $email_exist=email_exists($email);
    if($email_exist){
        $user = get_user_by( 'email', $email );
        $data['status']     = "error";
       $data['errormsg']   = __('Email already exist');
       $data['error_code'] = "invalid_email";
       $data['error_email'] = "already_email";
       $data['user_pass'] = get_user_meta( $user->ID, 'user_pass' ,true);
       $data['user_email'] = $email;
       $data['user_name'] = $username;
       return new WP_REST_Response($data, 403);
    }

    // if username already exist
    $username_exist=username_exists($username);
    if($username_exist){
        $user = get_user_by( 'login', $username );
        
       $data['status']     = "error";
       $data['errormsg']   = __('Username already exist');
       $data['error_code'] = "invalid_username";
       $data['error_user'] = "already_user";
       $data['user_pass'] = get_user_meta( $user->ID, 'user_pass' ,true);
       $data['user_name'] = $username;
       return new WP_REST_Response($data, 403);
    }

    // create user
    if($password){
        $passwordok=$password;
    }else{
        $passwordok = md5(wp_generate_password());
    }

    $userdata = array(
        'user_login' =>  $username,
        'user_email'   =>  $email,
        'user_pass'  =>  $passwordok // When creating an user, `user_pass` is expected.
    );
     
    $user_id = wp_insert_user( $userdata ) ;
    // $password= md5(wp_generate_password());
    // $user_id = wp_create_user($username, $passwordok, $email);

    // Generate a random key.
    $key = md5( wp_generate_password() );
    // Save this for the new user account.
    add_user_meta($user_id, 'activation_key', $key);
    add_user_meta($user_id, 'user_pass', $passwordok);
    $activation_link = site_url().'/wp-json/mobileapi/activation/?activation_key='.$key;

    // send mail
    $body='Dear '.$username.'';
    $body .= '<br/><br/>';
    $body .= "You can activate your Zambian Watchdog profile by clicking this link:";
    $body .= '<br/><br/>';
    $body .= $activation_link;
    $body .= '<br/><br/>';
    $body .= "Log into our website or app now to join the discussion.";
    $body .= '<br/><br/>';
    $body .= "If you did not register, you can delete this email or contact us to have your profile deleted.";
    $body .= '<br/><br/>';
    $body .= "Zambian Watchdog";
    $body .= '<br/>';
    $body .= "https://www.zambiawatchdog.com/";
    
    $headers  = "From:Zambian Watchdog <noreply@zambiawatchdog.com>\r\n";
    $headers .= "MIME-Version: 1.0\r\n";
    $headers .= "Content-Type: text/html; charset=ISO-8859-1\r\n";
    
    wp_mail( $email, 'Verify your account', $body, $headers );

    $data['msg']  = "Profile Successfully Created !";
    return new WP_REST_Response($data, 200);


}


function activation(){
  // check activation key
  if(isset($_GET['activation_key'])){
     // Get the user account the key is for.
        $users = get_users( array(
            'meta_key'    => 'activation_key',
            'meta_value'  => $_GET['activation_key'],
            'number'      => 1,
            'count_total' => false
        ));

        if($users){
           foreach( $users as $user ){
               // The provided activation key was valid, Auth Cookies generated.
               $adt_rp_key = get_password_reset_key( $user );
               $user_login = $user->user_login;
               wp_redirect(network_site_url("wp-set-new-password.php?action=rp&key=$adt_rp_key&login=".$user_login, 'login'),301);
               exit;
            }
        }
  }

}

// Get User ID by token
function GetMobileAPIUserByIdToken($token){
    $decoded_array = array();
    $user_id = 0;
    if ($token) {
        $decoded = JWT::decode($token, JWT_AUTH_SECRET_KEY, array('HS256'));

        $decoded_array = (array) $decoded;
    }
    if (count($decoded) > 0) {
        $user_id = $decoded_array['data']->user->id;
    }
    return $user_id;
}


function updateProfile($request){
    global $wpdb;
    $data  = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    );

   
    $param = $request->get_params();

    $token            = $param['token'];
    $email            = $param['email'];
    $username         = $param['username'];
    
   
    $user_id = GetMobileAPIUserByIdToken($token);

    if(!$user_id){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid token');
       $data['error_code'] = "invalid_token";
       return new WP_REST_Response($data, 403);	
    }
    
    if ($email != '' && $username != '') {

        if(!filter_var($email, FILTER_VALIDATE_EMAIL)){
           $data['status']     = "error";
           $data['errormsg']   = __('This is not a Valid Email.');
           $data['error_code'] = "invalid_email";
           return new WP_REST_Response($data, 403);
        }

        // if email already exist
        $already_exist=email_exists($email);
        if($already_exist && $already_exist!=$user_id){
           $data['status']     = "error";
           $data['errormsg']   = __('Email already exist');
           $data['error_code'] = "invalid_email";
           return new WP_REST_Response($data, 403);
        }

        // if username already exist
        $already_exist=username_exists($username);
        if($already_exist && $already_exist!=$user_id){
           $data['status']     = "error";
           $data['errormsg']   = __('Username already exist');
           $data['error_code'] = "invalid_username";
           return new WP_REST_Response($data, 403);
        }
        
        $userdata= array();
        $userdata['ID']            = $user_id;
        $userdata['user_email']    = $email;
        $userdata['user_nicename'] = $username;
        //$userdata['user_login'] =    $username;
        $userdata['display_name']  = $username;
        $userdata['first_name']    = $username;


        
    }

    wp_update_user($userdata);

    // update username
    $sql="UPDATE {$wpdb->prefix}users SET user_login='".$username."' where ID='".$user_id."'";          
    $result=$wpdb->query($sql);

    
    $data['msg']  = "Profile Successfully Updated !";
    $res_data= array();
    $res_data['token']= $token;
    $res_data['user_email']= $email;
    $res_data['user_display_name']= $username;
    $res_data['user_nicename']= $username;
    
    $data['res'] = $res_data;
    return new WP_REST_Response($data, 200);
    
}




function getUserProfile($request){
    $data = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    );
    
    $param = $request->get_params();
    
    $user_id  = $param['user_id'];
    //-------------------------------
    $userData = array();
    
    $user_info = get_userdata($user_id);
    
    $userData['user_id']       = $user_info->ID;
    $userData['email']         = $user_info->user_email;
    $userData['user_nicename'] = $user_info->user_nicename;
    $userData['first_name']    = get_user_meta($user_id, 'first_name', true);
    $userData['phone_number']  = get_user_meta($user_id, 'phone_number', true);
    
    return new WP_REST_Response($userData, 200);
}



/* Retrieve Password */
function forget_password($request){
	global $wp_hasher,$wpdb;
	$data = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    );
	
	$param = $request->get_params();
    $username  = $param['username'];
	if(!empty($username)){
	$check_username_exist=username_exists($username);
		if(!empty($check_username_exist)){
			$user_data=get_user_by('login', $username);
			$user_email=$user_data->data->user_email;
			
			// generate key 
			$key = wp_generate_password( 20, false );
			do_action( 'retrieve_password_key', $user_login, $key );
			if ( empty( $wp_hasher ) ) {
				require_once ABSPATH . 'wp-includes/class-phpass.php';
				$wp_hasher = new PasswordHash( 8, true );
			}
			$hashed = time() . ':' . $wp_hasher->HashPassword( $key );
			$wpdb->update( $wpdb->users, array( 'user_activation_key' => $hashed ), array( 'user_login' => $username ) ); 
			
			
			// email structure
			
			$message = __('Dear '.$username.'') . "\r\n\r\n";
			$message .= __('Someone requested a password reset on your profile. If this was a mistake, just ignore this email and nothing will happen:') . "\r\n\r\n";

			$message .= __('You can reset your password by clicking this link:') . "\r\n\r\n";

			$message .= '<' . network_site_url("wp-set-new-password.php?action=rp&key=$key&case=resetpass&login=" . rawurlencode($username), 'login') . ">\r\n\r\n";
			
			$message .= __('Zambian Watchdog') . "\r\n";

			$message .= __('https://www.zambiawatchdog.com') . "\r\n\r\n";
			
			$title = "Password Reset";
			
			if ( $message && !wp_mail($user_email, $title, $message) ){
				$data['status']     = "error";
				$data['errormsg']   = __('The e-mail could not be sent. Possible reason: your host may have disabled the mail() function...');
				$data['error_code']   = __('email_status');
				return new WP_REST_Response($data, 403);
			} else {
				$data['status']     = "ok";
				$data['msg']   = __('Link for password reset has been emailed to you. Please check your email.');
				$data['success_code']   = __('email_status');
			}
			
			
		} else{ 	
			$data['status']     = "error";
			$data['errormsg']   = __('Username not exist');
			$data['error_code']   = __('username');
			return new WP_REST_Response($data, 403);
		}
	} else {
			$data['status']     = "error";
			$data['errormsg']   = __('Please fill username field');
			$data['error_code']   = __('username');
			return new WP_REST_Response($data, 403);
	}
	return new WP_REST_Response($data, 200);
}

/*
function get_related_post($request){
    $args = array();
    $option=null;
    $default_options=array();
    $given = array();
    $data = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    ); 

   $param = $request->get_params();
   $post_id  = $param['post_id'];
   // get current post categories and tags
   $categories = get_the_category($post_id);
   $cat_ids= array();
   foreach($categories as $cat){
       $cat_ids[]= $cat->cat_ID;
   }

   $tags = get_the_tags($post_id);
   $tag_ids= array();
   foreach($tags as $tag){
       $tag_ids[]= $tag->term_id;
   }

   // get current post
   $current_post=get_post($post_id);
   
   
   $args=array(
	  'tag__in' => $tag_ids,
	  'post__not_in' => array($post_id),
    'category__in' => $cat_ids, 
	  'posts_per_page'=>5, // Number of related posts to display.
	  'orderby' => 'rand', // random post out of 10
	  'order' => 'DESC',
	  'caller_get_posts'=>1,
	  
	  'date_query' => array(
        array(
            'year'  => date('Y', strtotime($current_post->post_date))
        ),
      ),

   );
   
   $my_query = new wp_query($args);
   // check if empty then show only categories post
   if(empty($my_query->posts)){
      $args=array(
		  'post__not_in' => array($post_id),
	    'category__in' => $cat_ids, 
		  'posts_per_page'=>5, // Number of related posts to display.
		  'orderby' => 'rand', // random post out of 10
		  'order' => 'DESC',
		  'caller_get_posts'=>1,

		  'date_query' => array(
	        array(
	            'year'  => date('Y')
	        ),
	      ),
      );

      $my_query = new wp_query($args);
   }

   $posts_arr= array();

   foreach($my_query->posts as $rel_post){
  	  $temp_arr= array();
  	  $temp_arr['id']= $rel_post->ID;
  	  $temp_arr['title']= $rel_post->post_title;
  	  $temp_arr['post_date']= timeago($rel_post->post_date);
  	  $featured_image= wp_get_attachment_image_src( get_post_thumbnail_id( $rel_post->ID ), 'single-post-thumbnail' );
  	  $temp_arr['featured_image']= $featured_image[0];

  	  $posts_arr[]= $temp_arr;
   }

   $data['related_post']= $posts_arr;
   return new WP_REST_Response($data, 200);
}
*/

function get_related_post($request){
  $data = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    ); 

   $param = $request->get_params();
   $post_id  = $param['post_id'];

   $yarpp = new YARPP;
   $related_posts = $yarpp->get_related($post_id);
   //print_r($related);
   //exit;

   $posts_arr= array();
   foreach($related_posts as $rel_post){
      $temp_arr= array();
      $temp_arr['id']= $rel_post->ID;
      $temp_arr['title']= $rel_post->post_title;
      $temp_arr['post_date']= timeago($rel_post->post_date);
      $featured_image= wp_get_attachment_image_src( get_post_thumbnail_id( $rel_post->ID ), 'single-post-thumbnail' );
      $temp_arr['featured_image']= $featured_image[0];

      $posts_arr[]= $temp_arr;
   }

   $data['related_post']= $posts_arr;
   return new WP_REST_Response($data, 200);

}

function timeago($date) {
   $timestamp = strtotime($date);	
   
   $strTime = array("second", "minute", "hour", "day", "month", "year");
   $length = array("60","60","24","30","12","10");

   $currentTime = time();
   if($currentTime >= $timestamp) {
		$diff     = time()- $timestamp;
		for($i = 0; $diff >= $length[$i] && $i < count($length)-1; $i++) {
		$diff = $diff / $length[$i];
		}

		$diff = round($diff);
		return $diff . " " . $strTime[$i] . "(s) ago ";
   }
}


function submitComment($request){
   global $wpdb;
    $data  = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    );

   
    $param = $request->get_params();

    $token = $param['token'];
    $post_id = $param['post_id'];
    $comment = $param['comment'];
    
    $user_id = GetMobileAPIUserByIdToken($token);

    if(!$user_id){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid token');
       $data['error_code'] = "invalid_token";
       return new WP_REST_Response($data, 403);	
    }

    // get user by user id
    $user_temp= get_user_by('ID', $user_id);
    $user= $user_temp->data;

    if(empty($user)){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid user');
       $data['error_code'] = "invalid_user";
       return new WP_REST_Response($data, 403);	
    }

    // check if comment and post id exist
    if($comment=='' || $post_id==''){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid request');
       $data['error_code'] = "invalid_request";
       return new WP_REST_Response($data, 403);
    }

	  $args = array(
	    'comment_post_ID' => $post_id,
	    'comment_author' => $user->user_login,
	    'comment_author_email' => $user->user_email,
	    'comment_author_url' => 'http://',
	    'comment_content' => $comment,
	    'comment_type' => '',
	    //'comment_parent' => 0,
	    'user_id' => $user->ID,
	    'comment_author_IP' => $_SERVER['REMOTE_ADDR'],
	    'comment_date' => current_time('mysql'),
	    'comment_approved' => 1,
	  );

	  //print_r($args); exit;
    if(wp_insert_comment($args)){
    	$data  = array(
	        "status" => "ok",
	        "msg"    => "comment submitted successfully",
	        "errormsg" => "",
	        'error_code' => ""
       );

       return new WP_REST_Response($data, 200);
    }else{
       $data['status']     = "error";
       $data['errormsg']   = __('Comment could not be submitted');
       $data['error_code'] = "invalid_request";
       return new WP_REST_Response($data, 403);	
    }
}


function replyComment($request){
    $data  = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    );

   
    $param = $request->get_params();

    $token = $param['token'];
    $post_id = $param['post_id'];
    $parent_cid = $param['parent_cid'];
    $reply = $param['reply'];
    
    $user_id = GetMobileAPIUserByIdToken($token);

    if(!$user_id){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid token');
       $data['error_code'] = "invalid_token";
       return new WP_REST_Response($data, 403); 
    }

    // get user by user id
    $user_temp= get_user_by('ID', $user_id);
    $user= $user_temp->data;

    if(empty($user)){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid user');
       $data['error_code'] = "invalid_user";
       return new WP_REST_Response($data, 403); 
    }

    // check if comment and post id exist
    if($parent_cid=='' || $post_id=='' || $reply==''){
       $data['status']     = "error";
       $data['errormsg']   = __('Invalid request');
       $data['error_code'] = "invalid_request";
       return new WP_REST_Response($data, 403);
    }

    $args = array(
      'comment_post_ID' => $post_id,
      'comment_author' => $user->user_login,
      'comment_author_email' => $user->user_email,
      'comment_author_url' => 'http://',
      'comment_content' => $reply,
      'comment_type' => '',
      'comment_parent' => $parent_cid,
      'user_id' => $user->ID,
      'comment_author_IP' => $_SERVER['REMOTE_ADDR'],
      'comment_date' => current_time('mysql'),
      'comment_approved' => 1,
    );

    //print_r($args); exit;
    if(wp_insert_comment($args)){
       $data  = array(
          "status" => "ok",
          "msg"    => "comment submitted successfully",
          "errormsg" => "",
          'error_code' => ""
       );

       return new WP_REST_Response($data, 200);
    }else{
       $data['status']     = "error";
       $data['errormsg']   = __('Comment could not be submitted');
       $data['error_code'] = "invalid_request";
       return new WP_REST_Response($data, 403); 
    }
}


function getComment($request){
   
   $data = array(
        "status" => "ok",
        "errormsg" => "",
        'error_code' => ""
    ); 

   $param = $request->get_params();
   $post_id  = $param['post_id'];

   // get all comment of current post
   $comments=get_comments( array('post_id' => $post_id, 'order' => 'ASC'));
   //print_r($comments); exit;
   
   $comments_arr= array();
   foreach($comments as $comment){
      if($comment->comment_parent==0){
          $temp= array();
          $temp['id'] = $comment->comment_ID;
          $temp['comment_author'] = $comment->comment_author;
          $temp['comment_date'] = $comment->comment_date;
          $temp['content'] = $comment->comment_content;
          $child= get_child($temp);
          if($child){
             $temp['child']= $child;
          }

          $comments_arr[]= $temp;
      }
   }

   //print_r($comments_arr); exit;

   return new WP_REST_Response($comments_arr, 200);
}


function get_child($comment){
    // child comment
    $args = array('parent' => $comment['id'], 'order' => 'ASC');
    $child_cmts = get_comments($args);
    
    $child_arr= array();
    if($child_cmts){
        foreach($child_cmts as $child_cmt){
            $temp_child= array();
            $temp_child['id'] = $child_cmt->comment_ID;
            $temp_child['comment_author'] = $child_cmt->comment_author;
            $temp_child['comment_date'] = $child_cmt->comment_date;
            $temp_child['content'] = $child_cmt->comment_content;
            $child_arr[]= $temp_child;
        }
    }

    return $child_arr;
}
?>